#-------------------------------------------------
#
# Project created by Qt5.9.1 2022-10-24T09:06:36
# created by HUAHAIYAN
#-------------------------------------------------

TEMPLATE = app

TARGET = NPotter

#INCLUDEPATH +=$$PWD/../boost/
#INCLUDEPATH +=$$PWD/../spline_library/

CONFIG += c++11

QT     += core gui network
QT     += serialport
QT     += svg
QT     += concurrent testlib #将类中的函数移到线程中

 #用于zip的压缩和解压，因为qt自带的zip是私有的，所以工程会报警告，若要消除警告可尝试第三方的zip库
QT     += gui-private

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

OBJECTS_DIR		+= obj
MOC_DIR                += moc
UI_DIR			+= forms
RCC_DIR			+= rccs

DEFINES += HAVE_CONFIG_H

SOURCES += \
    main.cpp \
    mainwindow.cpp \
    printviewwindow.cpp \
    datafile/hpgl/importhpgl.cpp \
    datafile/hpgl/marker.cpp \
    datafile/hpgl/vectorfont.cpp \
    datafile/view/mygraphicsitem.cpp \
    datafile/view/mygraphicsscene.cpp \
    datafile/view/mygraphicsview.cpp \
    printnumbersetdialog.cpp \
    drawingsetdialog.cpp \
    historydialog.cpp \
    plottersetdialog.cpp \
    startsetdialog.cpp \
    machine/machine.cpp \
    datafile/hpgl/plotbitmap.cpp \
    datafile/qrencode/bitstream.c \
    datafile/qrencode/mask.c \
    datafile/qrencode/mmask.c \
    datafile/qrencode/mqrspec.c \
    datafile/qrencode/qrencode.c \
    datafile/qrencode/qrinput.c \
    datafile/qrencode/qrspec.c \
    datafile/qrencode/rsecc.c \
    datafile/qrencode/split.c \
    machine/comm/comm.cpp \
    machine/comm/crc16.cpp \
    machine/comm/crc32.cpp \
    printinfodialog.cpp \
    addmachinedialog.cpp \
    machine/bmp/bwbmp.cpp \
    machine/bmp/creatprintbmp.cpp \
    machine/tcp/qbindtcpsocket.cpp \
    machine/tcp/tcpclient.cpp \
    datafile/view/drawdata.cpp \
    datafile/dxf/dxfhelper.cpp \
    datafile/dxf/dxfreader.cpp

FORMS += \
    mainwindow.ui \
    printviewwindow.ui \
    printnumbersetdialog.ui \
    drawingsetdialog.ui \
    historydialog.ui \
    plottersetdialog.ui \
    startsetdialog.ui \
    printinfodialog.ui \
    addmachinedialog.ui

HEADERS += \
    main.h \
    mainwindow.h \
    printviewwindow.h \
    datafile/hpgl/importhpgl.h \
    datafile/hpgl/marker.h \
    datafile/hpgl/vectorfont.h \
    datafile/view/mygraphicsitem.h \
    datafile/view/mygraphicsscene.h \
    datafile/view/mygraphicsview.h \
    printnumbersetdialog.h \
    drawingsetdialog.h \
    historydialog.h \
    plottersetdialog.h \
    startsetdialog.h \
    datafile/hpgl/typedef.h \
    machine/machine.h \
    datafile/hpgl/plotbitmap.h \
    datafile/qrencode/bitstream.h \
    datafile/qrencode/config.h \
    datafile/qrencode/mask.h \
    datafile/qrencode/mmask.h \
    datafile/qrencode/mqrspec.h \
    datafile/qrencode/qrencode.h \
    datafile/qrencode/qrencode_inner.h \
    datafile/qrencode/qrinput.h \
    datafile/qrencode/qrspec.h \
    datafile/qrencode/rsecc.h \
    datafile/qrencode/split.h \
    machine/comm/protocol.h \
    machine/comm/comm.h \
    machine/comm/typedef.h \
    machine/comm/crc16.h \
    machine/comm/crc32.h \
    printinfodialog.h \
    addmachinedialog.h \
    machine/bmp/bwbmp.h \
    machine/bmp/creatprintbmp.h \
    machine/tcp/qbindtcpsocket.h \
    machine/tcp/tcpclient.h \
    machine/printinfo/mcfiles.h \
    datafile/view/drawdata.h \
    datafile/dxf/dxfhelper.h \
    datafile/dxf/dxfreader.h \
    datafile/dxf/dxflib/DxfMath.h \
    datafile/dxf/dxflib/GroupCode.h \
    datafile/dxf/dxflib/PDSMath.h \
    datafile/dxf/dxflib/ReadASTM.h \
    datafile/dxf/dxflib/ReadAutoCAD.h \
    datafile/dxf/dxflib/ReadDxfFile.h \
    datafile/dxf/dxflib/ReadTIIP.h \
    datafile/dxf/dxflib/WriteASTM.h \
    datafile/dxf/dxflib/WriteAutoCAD.h \
    datafile/dxf/dxflib/WriteDxfFile.h \
    datafile/dxf/dxflib/DxfMath.h \
    datafile/dxf/dxflib/GroupCode.h \
    datafile/dxf/dxflib/PDSMath.h \
    datafile/dxf/dxflib/ReadASTM.h \
    datafile/dxf/dxflib/ReadAutoCAD.h \
    datafile/dxf/dxflib/ReadDxfFile.h \
    datafile/dxf/dxflib/ReadTIIP.h \
    datafile/dxf/dxflib/WriteASTM.h \
    datafile/dxf/dxflib/WriteAutoCAD.h \
    datafile/dxf/dxflib/WriteDxfFile.h \
    datafile/dxf/dxflib/PDSMath/3BSpline.h \
    datafile/dxf/dxflib/PDSMath/PDSAlgorithm.h \
    datafile/dxf/dxflib/PDSMath/PDSBezier.h \
    datafile/dxf/dxflib/PDSMath/PDSFormula.h \
    datafile/dxf/dxflib/PDSMath/PDSLocate.h \
    datafile/dxf/dxflib/PDSMath/PDSMath.h \
    datafile/dxf/dxflib/PDSMath/PDSMathExtern.h \
    datafile/dxf/dxflib/PDSMath/PDSMathGlobal.h \
    datafile/dxf/dxflib/PDSMath/PDSNurbs.h \
    datafile/dxf/dxflib/PDSMath/PDSReadWriteFile.h \
    datafile/dxf/dxflib/PDSMath/PDSUID.h \
    datafile/dxf/dxflib/PDSMath/PDSUnit.h \
    datafile/dxf/dxflib/PDSMath/Point3D.h \
    datafile/dxf/dxflib/PDSMath/StdAfx.h \
    datafile/dxf/dxflib/PDSMath/UnzipFile.h \
    datafile/dxf/dxflib/PDSMath/UnzipFile_Memory.h \
    datafile/dxf/dxflib/PDSMath/zconf.h \
    datafile/dxf/dxflib/PDSMath/ZipCompress.h \
    datafile/dxf/dxflib/PDSMath/ZipException.h \
    datafile/dxf/dxflib/PDSMath/ZipFile.h \
    datafile/dxf/dxflib/PDSMath/ZipFile_Memory.h \
    datafile/dxf/dxflib/PDSMath/ZipStruct.h \
    datafile/dxf/dxflib/PDSMath/zlib.h \
    datafile/dxf/dxflib/PDSMath/ZUBaseFile.h \
    datafile/dxf/dxflib/PDSMath/ZUBaseFile_Memory.h

TRANSLATIONS += chinese.ts\
english.ts

RESOURCES += \
    res.qrc

!debug: {
    LIBS += $$PWD/../../datafile/dxf/dxflib/ReadDXFFileLib_R
    LIBS += $$PWD/../../datafile/dxf/dxflib/RPAPI_R
    LIBS += $$PWD/../../datafile/dxf/dxflib/WriteDXFFileLib_R
} else {
    LIBS += $$PWD/../../datafile/dxf/dxflib/ReadDXFFileLib_D
    LIBS += $$PWD/../../datafile/dxf/dxflib/RPAPI_D
    LIBS += $$PWD/../../datafile/dxf/dxflib/WriteDXFFileLib_D
}
