/********************************************************************
:2017911
  :PDSBezier.h
ԭʼ:
    :λBezier

޸ļ¼:
  汾       ޸                ޸
*********************************************************************/
#ifndef _PDS_BEZIER_H_
#define _PDS_BEZIER_H_

#include <afxwin.h>
#include <afxtempl.h>
#include "PDSMath.h"

//Bezier
class CPDSBezierPoint : public CObject
{
public:
  CDBLPoint m_ptPoint;  // ,Bezier߱Ҫõ
  CDBLPoint m_ptPrev;  // ǰߵ
  CDBLPoint m_ptNext;  // ߵ

  double m_dParam;  // õӦĲֵ,ڼBezierߵʵʵĹ,Ĭֵ:0

public:
  CPDSBezierPoint(void);
  CPDSBezierPoint(CDBLPoint ptPoint, CDBLPoint ptPrev, CDBLPoint ptNext, double dParam = 0.0);
  CPDSBezierPoint(CPoint ptPoint, CPoint ptPrev, CPoint ptNext, double dParam = 0.0);
  CPDSBezierPoint(CPDSBezierPoint& rhs);
  virtual ~CPDSBezierPoint(void);
  CPDSBezierPoint& operator=(CPDSBezierPoint& rhs);
  BOOL operator==(CPDSBezierPoint& rhs);  // Ƚm_ptPointǷ
  BOOL operator!=(CPDSBezierPoint& rhs);  // Ƚm_ptPointǷ

  void Initial(void);

  //ʹptPoint,ptPrev,ptNextthis
  void SetPoint(CPoint ptPoint, CPoint ptPrev, CPoint ptNext);

  //ȡptPoint,ptPrev,ptNext
  void GetPoint(CPoint& ptPoint, CPoint& ptPrev, CPoint& ptNext);
};

//Bezier
class CPDSBezierPointList : public CList<CPDSBezierPoint,CPDSBezierPoint>
{
public:  //չı
public:  //չķ

  CPDSBezierPointList& operator=(CPDSBezierPointList& rhs);  //ֵ
  CPDSBezierPoint& operator[](int iIndex);  //ֵ,Խ

  //listPointthis
  void SetPoint(CList<CPoint,CPoint>& listPoint);

  //thislistPoint
  void GetPoint(CList<CPoint,CPoint>& listPoint);

  POSITION AddWithoutDuplicate(CPDSBezierPoint ptBezierPoint, BOOL bAddTail = TRUE);

  void AddWithoutDuplicate(CPDSBezierPointList& listBezierPoint, BOOL bAddTail = TRUE);

  //ݸĲֵ,ֵ
  int FindParamIndex(double dParam);

  //ȡ
  double GetLength(void);

  //thisת
  void Reverse(void);
};

//Bezier
class CPDSBezierCurve : public CObject
{
public:
  //Աװһ,д,Bezierߵļ㺯ʹóԱ
  CPDSBezierPointList m_listCtrlPoint;  // Ƶ,ǰߵ
  CPDSBezierPointList m_listRealPoint;  // ʵʵ,ǰߵֵ
  int m_iBezierDegree;  // BezierߵĴ,λ,Ĭֵ:3

public:
  CPDSBezierCurve(void);
  CPDSBezierCurve(CPDSBezierCurve& rhs);
  virtual ~CPDSBezierCurve(void);
  CPDSBezierCurve& operator=(CPDSBezierCurve& rhs);

  void Initial(void);

  //Bezier
  //:
  //  listCtrlPoint  Ƶ,ǰһnextߵһprevߵ֮ʵʵ
  //  bClose         =true պ,GetTail()GetHead()֮ĲҪ,=false 
  //  iBezierDegree  BezierߵĴ,=2=3
  //  dMaxError      ֵ
  //:
  //  listRealPoint  ʵʵ
  static void CalculateBezierCurve(CPDSBezierPointList& listCtrlPoint, BOOL bClose, int iBezierDegree, double dMaxError, CPDSBezierPointList& listRealPoint);

protected:

  //֮Bezier
  //:
  //  ptPrevBezierPoint  ǰһBezier,nextߵ
  //  ptNextBezierPoint  һBezier,prevߵ
  //  iBezierDegree      BezierߵĴ,=2=3
  //  dMaxError          ֵ
  //:
  //  listRealPoint  ʵʵ
  static void CalculateBezierBetweenTwoPoint(CPDSBezierPoint ptPrevBezierPoint, CPDSBezierPoint ptNextBezierPoint, int iBezierDegree, double dMaxError, CPDSBezierPointList& listRealPoint);

  //ݸĲֵBezier
  //:
  //  ptPrevBezierPoint  ǰһBezier,nextߵ
  //  ptNextBezierPoint  һBezier,prevߵ
  //  iBezierDegree      BezierߵĴ,=2=3
  //  dParam             ֵ,0<=dParam<=1
  //ֵ:
  //  Bezier
  static CPDSBezierPoint CalculateBezierPoint(CPDSBezierPoint ptPrevBezierPoint, CPDSBezierPoint ptNextBezierPoint, int iBezierDegree, double dParam);

  //ݼеĲ
  //:
  //  ptPrevBezierPoint  ǰһBezier,nextߵ
  //  ptNextBezierPoint  һBezier,prevߵ,㹹һBezier
  //  iBezierDegree      BezierߵĴ,=2=3
  //  ptBezierPoint1     öBezierϵĵ1
  //  ptBezierPoint2     öBezierϵĵ2
  //:
  //  dParam1  ,1Ĳ2Ĳ֮
  //  dParam2  ,1Ĳ2Ĳ֮,ҴdParam1
  //ֵ:
  //  =2 ,=1 һ,=0 ûн
  static int CalculateTangentParam(CPDSBezierPoint ptPrevBezierPoint, CPDSBezierPoint ptNextBezierPoint, int iBezierDegree, CPDSBezierPoint ptBezierPoint1, CPDSBezierPoint ptBezierPoint2, double& dParam1, double& dParam2);
};

#endif  // _PDS_BEZIER_H_